#include<bits/stdc++.h>
#define int long long
using namespace std;

const int INF=2e9+1;

int n,k;
vector<int>a;

bool check(int mid)
{
    int cnt=0;

    int cur=0;
    for(int i=0;i<n;i++)
    {
        cur=cur|a[i];
        if((cur&mid)==mid)
        {
            cur=0;
            cnt++;
        }
    }

    return cnt>=k;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    a.resize(n);
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
    }

    int l=0,r=INF,m,ans;
    while(l<=r)
    {
        m=(l+r)/2;
        if(check(m))
        {
            ans=m;
            l=m+1;
        }
        else
        {
            r=m-1;
        }
    }

    cout<<ans<<'\n';

    return 0;
}